#include <utils/genericptr.hh>

namespace utils
{
    namespace support
    {
	GenericPtrHelper::CountType GenericPtrHelper::addRef(void* p,
							     GenericPtrHelper::Deleter* deleter,
							     GenericPtrHelper::GenericFunctionPtr func,
							     void* origPtr)
	{
	    if(!p)
		return nullCount();
	    
	    std::pair<CountType, bool> insertResult(
		counts.insert(CountMap::value_type(p,
						   CountObject(1,deleter,func,origPtr))));
	    
	    CountType it=insertResult.first;
	    
	    if(!insertResult.second)
	    {
		addRef(it);
	    }
	    return it;
	}
	GenericPtrHelper::CountType GenericPtrHelper::addRef(void* p,
							     GenericPtrHelper::CountType parentCount)
	{
	    if(!p)
		return nullCount();
	    
	    std::pair<CountType, bool> insertResult(
		counts.insert(CountMap::value_type(p,
						   CountObject(1,parentCount))));
	    
	    CountType it=insertResult.first;
	    
	    if(!insertResult.second)
	    {
		addRef(it);
	    }
	    return it;
	}
	void GenericPtrHelper::removeRef(GenericPtrHelper::CountType it)
	{
	    if(it!=nullCount() && 
	       !--(it->second.count))
	    {
		if(it->second.parentCount==nullCount())
		    it->second.deleter->doDelete(it->second.deleteFunction,
						 it->second.originalPtr);
		counts.erase(it);
	    }
	}

	GenericPtrHelper::CountMap GenericPtrHelper::counts;
    }
}
